#pragma once

// STD/STL
#include <memory>

// ArmarX
#include <RobotAPI/libraries/aron/core/data/variant/container/Dict.h>

namespace armarx::armem::server::ltm
{
    class DictConverter;
    using DictConverterPtr = std::shared_ptr<DictConverter>;

    class DictConverter
    {
    public:
        enum class ConverterType
        {
            Str,
            Binary
        };

        DictConverter(const ConverterType t, const std::string& s):
            type(t),
            suffix(s)
        {}
        virtual ~DictConverter() = default;

        virtual std::vector<unsigned char> convert(const aron::data::DictPtr& data) = 0;
        virtual aron::data::DictPtr convert(const std::vector<unsigned char>& data) = 0;

        const ConverterType type;
        const std::string suffix;
    };
}
