#pragma once

#include <filesystem>

// Base Class
#include "../base/detail/EntitySnapshotBase.h"
#include "detail/DiskStorage.h"

namespace armarx::armem::server::ltm::disk
{

    class EntitySnapshot :
            public EntitySnapshotBase,
            public DiskMemoryItem
    {
    public:
        EntitySnapshot(const std::filesystem::path&, const LongTermMemoryPipeline& p);

    protected:
        void _loadAll(armem::wm::EntitySnapshot&) const override;
        void _load(armem::wm::EntitySnapshot&) const override;
        void _store(const armem::wm::EntitySnapshot&) const override;

        std::string getExpectedFolderName() const override;

    };

} // namespace armarx::armem::server::ltm::disk
