#pragma once

#include "Skill.h"

#include <RobotAPI/libraries/aron/core/type/variant/container/Object.h>

// Debug
#include <RobotAPI/libraries/aron/converter/json/NLohmannJSONConverter.h>

namespace armarx
{
    namespace skills
    {
        template <class AronT>
        class SpecializedSkill : public Skill
        {
        public:
            using Skill::Skill;
            virtual ~SpecializedSkill() = default;

            /// returns the accepted type of the skill
            static armarx::aron::type::ObjectPtr GetAcceptedType()
            {
                return AronT::ToAronType();
            }

            /// Override this method with the actual implementation. The callback is for status updates to the calling instance
            virtual Status _execute(const AronT& params, const CallbackT& callback = [](const aron::data::DictPtr& returnValue) { (void) returnValue; })
            {
                (void) params;

                ARMARX_WARNING_S << "You have to override this method!";
                return Status::Succeeded;
            }

            /// Do not use anymore
            Status _execute(const aron::data::DictPtr& params, const CallbackT& callback = [](const aron::data::DictPtr& returnValue) { (void) returnValue; }) final
            {
                AronT p;
                //ARMARX_IMPORTANT << aron::converter::AronNlohmannJSONConverter::ConvertToNlohmannJSON(params).dump(2);
                p.fromAron(params);

                return _execute(p, callback);
            }
        };
    }
}
